close all
clear all
clc

% Dati
x = [-5 -3 -3 1 1 3  4 4   6  8  8]';
y = [18  7  5 0 2 7 16 10 50 67 70]';

% Costruzione di A
A = CostruisciA2(x);
% Dimensione del problema
n = 3;


% Risoluzione via equazioni normali con cholesky
K = A'*A;
F = A'*y;
R = chol(K);
a_chol = R\(R'\F)


% Risoluzione utilizzando la QR
[Q,R] = qr(A);
R1 = R(1:n,1:n);
c = Q'*y;
c = c(1:n);
a_qr = R1\c


% Risoluzione utilizzando SVD
[U,S,V] = svd(A);
S = diag(S);
d = U'*y;
ytmp = d(1:length(S))./S;
a_svd = V*ytmp

% Utilizzando il comando MatLab
a_m = A\y 

% Disegno la soluzione e la retta dei minini quadrati
a = a_qr;
xval = linspace(min(x),max(x));
yval = a(1)+a(2)*xval+a(3)*xval.^2;
figure;
h = plot(xval,yval,'k-');
set(h,'LineWidth',2);
hold on;
h = plot(x,y,'*');
set(h,'LineWidth',2);
hold off
