% Minimizzazione con SVD e QR
close all
clear all
clc

% % Piu' righe che colonne
% QR
nr = 4
nc = 3
n = min([nr,nc])
A = rand(nr,nc);
b = rand(nr,1);
[Q,R] = qr(A)

R1 = R(1:n,1:n)
c = Q'*b;
c1 = c(1:n);
xqr = R1\c1
norm(b-A*xqr)
norm(c(n+1:end))

% SVD
[U,S,V] = svd(A)
Sdiag = diag(S)
d = U'*b;
y1 = d(1:n)./Sdiag;
xsvd = V*y1;
norm(b-A*xsvd)
norm(d(n+1:end))


% % Piu' colonne che righe
% QR
nr = 3
nc = 4
n = min([nr,nc])
A = rand(nr,nc);
b = rand(nr,1);
[Q,R] = qr(A)

R1 = R(1:n,1:n)
c = Q'*b;
c1 = c(1:n);
xqr = zeros(nc,1);
xqr(1:n) = R1\c1

norm(b-A*xqr)
norm(c(n+1:end))

% SVD
[U,S,V] = svd(A)
Sdiag = diag(S)
d = U'*b;
y1 = zeros(nc,1)
y1(1:n) = d(1:n)./Sdiag;
xsvd = V*y1;
norm(b-A*xsvd)
norm(d(n+1:end))


norm(xsvd)
norm(xqr)

% ESEMPIO DI MINIMI QUADRATI
% --------------------------
x = [ 0 1 1 2]'
y = [-1 1 3 5]'
A = [y.^0,y.^1];

% Cholesky
% --------
AtA = A'*A
Aty = A'*y
R = chol(AtA)
x_chol = R\(R'\Aty)

% QR
% --
[Q,R] = qr(A)
c = Q'*y
c1 = c(1:2)
R1 = R(1:2,1:2)
x_qr = R1\c1

% SVD
% ---
[U,S,V] = svd(A)
d = U'*y
d1 = d(1:2)
z = d1./diag(S)
x_svd = V*z

% MatLab
% ------
x = A\y

% ESEMPIO DI SISTEMA SOTTO-DETERMINATO
% ------------------------------------
A = [1 2 1 1; 1 -2 1 -1];
b = [2 0]'

% QR con pivoting e versione economica
% ------------------------------------
[Q,R,E] = qr(A,0)
c = Q'*b
x_qr = zeros(4,1);
x_qr(E(1:2)) = R(1:2,1:2)\c

% SVD in versione economica
% -------------------------
[U,S,V] = svd(A,0)
d = U'*b
z = zeros(4,1);
z(1:2) = d./diag(S)
x_svd = V*z
norm(x_qr)^2
norm(x_svd)^2





