% svd applicata alle immagini
close all
clear all
clc

[A,map]= imread('lena.gif');        % caricamento immagine
B = im2double(A,'indexed');         % conversione in numeri reali

figure;
imshow(B,map);                      % visualizzazione

[U,S,V]=svd(B);                     % decomposizione ai valori singolari

k = 128;                            % numero di valori singolari che vogliamo tenere
C = zeros(size(B));
for j=1:k
    C = C + S(j,j)*U(:,j)*V(:,j)';
end

figure;
imshow(C,map);                      % visualizza immagine

% Disegno valori singolari
figure;
stem(diag(S));


% i primi 16 valori principali
figure;
C = zeros(size(B));
for k=1:16
    C = C + S(k,k)*U(:,k)*V(:,k)';
    subplot(4,4,k);
    imshow(C,map);                      % visualizza immagine
end
